<?php

namespace app\controllers\mikrotik\ip\firewall;

require_once 'PEAR2_Net_RouterOS-1.0.0b5.phar';

use Yii;
use yii\helpers\Url;
use yii\filters\AccessControl;
use yii\web\Controller;
use yii\filters\VerbFilter;
use yii\data\ArrayDataProvider;
use app\models\mikrotik\MikrotikSideMenu;
use app\models\mikrotik\ip\firewall\Nat;
use app\models\mikrotik\ip\firewall\Addresslists;
use app\models\mikrotik\ip\firewall\Mangle;
use app\models\mikrotik\ip\firewall\Layer7protocols;
use app\models\mikrotik\Interfaces;

class Layer7protocolsController extends Controller {

    public function behaviors() {
        return [
            'access' => [
                'class' => AccessControl::className(),
                'except' => ['index'],
                'rules' => [
                    [
                        'actions' => ['create'],
                        'allow' => true,
                        'roles' => ['mikrotik_ipCreateFirewallLayer7Protocols'],
                    ],
                    [
                        'actions' => ['delete'],
                        'allow' => true,
                        'roles' => ['mikrotik_ipDeleteFirewallLayer7Protocols'],
                    ],
                    [
                        'actions' => ['update'],
                        'allow' => true,
                        'roles' => ['mikrotik_ipUpdateFirewallLayer7Protocols'],
                    ],
                    [
                        'actions' => [],
                        'allow' => true,
                        'roles' => ['admin'],
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'logout' => ['post'],
                ],
            ],
        ];
    }

    public function actions() {
        return [
            'error' => [
                'class' => 'yii\web\ErrorAction',
            ],
            'captcha' => [
                'class' => 'yii\captcha\CaptchaAction',
                'fixedVerifyCode' => YII_ENV_TEST ? 'testme' : null,
            ],
        ];
    }

    public function actionIndex() {
        $menu = new MikrotikSideMenu();
        $model = new Layer7protocols();
        $model->getAll();
        return $this->render('/mikrotik/ip/firewall/layer7protocols/index', [
                    'menu' => $menu->getMenu(),
                    'model' => $model,
        ]);
    }

    public function actionUpdate() {
        $id = Yii::$app->request->get('id');
        $model = new Layer7protocols();
        $menu = new MikrotikSideMenu();
        if ($model->load(Yii::$app->request->post()) && $model->validate()) {
            $model->update($id);
            return $this->redirect(Url::toRoute('mikrotik/ip/firewall/firewall/index'));
        } else {

            $model->get($id);
        }


        return $this->render('/mikrotik/ip/firewall/layer7protocols/index', [
                    'menu' => $menu->getMenu(),
                    'model' => $model,
                    'action' => 'update',
        ]);
    }

    public function actionCreate() {
        $menu = new MikrotikSideMenu();
        $model = new Layer7protocols();

        if ($model->load(Yii::$app->request->post()) && $model->validate()) {
            $model->create();
            return $this->redirect(Url::toRoute('mikrotik/ip/firewall/firewall/index'));
        }

        return $this->render('/mikrotik/ip/firewall/layer7protocols/index', [
                    'menu' => $menu->getMenu(),
                    'model' => $model,
                    'action' => 'create',
        ]);
    }

    public function actionDelete() {
        $id = Yii::$app->request->get('id');
        $model = new Layer7protocols();
        $model->delete($id);
        return $this->redirect(Url::toRoute('mikrotik/ip/firewall/firewall/index'));
    }

}
